/*
  EXAMPLE 2B ANALYSIS OF MAIZE RILS FROM CROSS B73 X MO17
  SOME DATA ARE MISSING
  PARENTAL LINES EXCLUDED TO PERMIT EASY ESTIMATION OF PROGENY VARIANCE
  EXPERIMENTAL DESIGN: 62 RILS TESTED IN 8 X 8 LATTICE DESIGNS WITH 2 REPLICATIONS AT EACH OF 4 LOCATIONS
  FOR THIS ANALYSIS WE WILL IGNORE INCOMPLETE BLOCKS AND ANALYZE AS RCBD AT EACH LOCATION
*/

options ls = 73 ps = 64 nocenter;

PROC IMPORT OUT= WORK.maize_rils 
            DATAFILE= "C:\Documents and Settings\jholland\My Documents\Handbook\example_data_sets_for_handbook\Example 2B maize B73 Mo17 RILs.csv" 
            DBMS=CSV REPLACE;
     GETNAMES=YES;
     DATAROW=2; 
RUN;


proc glm data = maize_rils;
title "GLM ANALYSIS OF MAIZE RILS UNBALANACED DATA SET";
class location rep RIL;
model mean_height = location rep(location) RIL RIL*location;
random location rep(location) RIL RIL*location/test;
lsmeans RIL;
run;

proc mixed data = maize_rils covtest;
title "MIXED MODELS ANALYSIS OF MAIZE RILS UNBALANCED DATA SET";
class location rep RIL;
model mean_height =/solution;
random location rep(location) RIL RIL*location/solution;
ods listing exclude solutionR;
ods output solutionR = random solutionF = fixed;
run;

*reduced model to obtain LRT for location, RIL, and RIL*location;
proc mixed data = maize_rils covtest;
title "MAIZE RILS REDUCED MODEL - NO LOCATION EFFECT";
class location rep RIL;
model mean_height =;
random rep(location) RIL RIL*location;

proc mixed data = maize_rils;
title "MAIZE RILS REDUCED MODEL - NO RIL EFFECT";
class location rep RIL;
model mean_height =;
random location rep(location) RIL*location;
run;

proc mixed data = maize_rils;
title "MAIZE RILS REDUCED MODEL - NO RIL*LOCATION EFFECT";
class location rep RIL;
model mean_height =;
random location rep(location) RIL;
run;

*get BLUPs to compare with LSmean to show estimability and shrinkage effects of mixed model;
data RILs; set random; if effect = "RIL";dum = 1; keep dum RIL estimate; run;
data mu; set fixed; dum = 1; mu = estimate; keep dum mu; run;
data RIL_BLUPs; merge RILs mu; by dum; BLUP = mu + estimate; run;
 


