path<-"/Users/cmaltec/Library/CloudStorage/GoogleDrive-cmaltec@ncsu.edu/My Drive/CS726_Grading/2016 lecture notes/Lecture_1 mm/Exercise/"

#rils <- read.csv(paste0(path,"Example 2A maize B73 Mo17 RILs.csv"))
rils <- read.csv(paste0(path,"Example 2B maize B73 Mo17 RILs.csv"))





library(car)
library(VCA)
attach(rils)

require(doBy, quiet=T)
require(lme4, quiet=T)

#LINEAR MODEL ANALYSIS ANOVA
m0 <- lm(mean_height~location*RIL + rep:location)
anova(m0)
Anova(m0,type="II", data=rils)


ma <- fitVCA(mean_height~location*RIL + rep:location, rils, method = "ANOVA")

ma

varPlot(form=mean_height~location*RIL + rep:location, rils)

# Polulation means ( LSMEANS )
RILMeans <- popMeans(m0, effect='RIL')


#mixed models analysis
#make sure that rep is a factor
rils <- within(rils, rep <- factor(rep))

mm <- lmer(mean_height ~ 1 + (1|RIL) + (1|location/rep) + (1|location:RIL),data=rils)
print(mm)
vc <- VarCorr(mm)
print(vc,comp=c("Variance"))
cc <- confint(mm,oldNames=FALSE)
ccv<-cc^2

#extractors
fixef(mm)
ranef(mm)


#fitted values
fitted(mm)

library(ggplot2)
#install.packages("stevemisc")
library(stevemisc)
# caterpillar plot
show_ranef(mm, "RIL")


#obtaining predictions
BLUP<-fixef(mm)+ranef(mm)$RIL



COMP<-cbind(BLUP, RILMeans$coef$estimate)




